-- Gitit on-page form test.

module Main where

import Prelude hiding (putStrLn)
import System.IO.UTF8
import BrownPLT.JavaScript
import BrownPLT.JavaScript.PrettyPrint
import Control.Monad
import Language.JSMW
import Language.JSMW.Arith

import DOMHelper

import BrownPLT.JavaScript.Syntax
import Control.Monad.RWS

import Foreign.WebIDL.Html2.HTMLInputElement hiding (set'value)
import Foreign.WebIDL.Html2.HTMLFormElement hiding (set'name)
import Foreign.WebIDL.Html2.HTMLDivElement
import Foreign.WebIDL.Dom.Document
import Foreign.WebIDL.Dom.Element
import Foreign.WebIDL.Dom.Node

instance JContainer THTMLDivElement
instance JContainer THTMLInputElement
instance JContainer THTMLFormElement

main = do
  putStrLn $ show $ stmt $ 
    FunctionStmt undefined (Id undefined "main") [] (getBlock (runJSMWWith currDocBody 0 q))
  putStrLn $ show $ stmt $
    ExprStmt undefined $ CallExpr undefined (VarRef undefined $ Id undefined "main") []

q = do
  doc <- ask >>= getm'ownerDocument
  cdiv <- getElementById (string "content") doc >>= return . asHTMLDivElement >>= once
  inside cdiv $ do
    container mkForm $ do
      passive $ mkText (string "year:")
      container mkInput $ do
        runSetters [set'name $ string "yr"]
      passive $ mkText (string "month:")
      container mkInput $ do
        runSetters [set'name $ string "mo"]
      container mkInput $ do
        runSetters [set'type $ string "submit"
                   ,set'name $ string "Calendar"]
      runSetters [set'method $ string "POST"   
                 ,set'action $ string "/Calendar/Example"]
    return unit



